> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Retry failed payment schedule items

POST https://rest.test.zuora.com/v1/payment-schedule-items/retry-payment
Content-Type: application/json

Retries failed payment schedule items. The payment method and payment gateway of the failed payment can be updated to new values before the retry.

Note that you can retry a payment schedule item only when the payment schedule item is either in the `Error` or `Pending` status.

**Note:**
- To manage and access this feature through the self-service interface, see [Manage Features](https://knowledgecenter.zuora.com/Zuora_Payments/Payments_Settings/Manage_Features) in the Knowledge Center.
- This operation is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/payments/payment-schedules/post-retry-payment-schedule-item

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a POSTRetryPaymentScheduleItemRequest.

- `items` (list of POSTRetryPaymentScheduleItemInfo, optional) — The maximum number of items allowable to pass is 10.

## Response

### 200

OK

- `items` (list of PaymentScheduleItemCommonResponse, optional)
- `success` (boolean, optional) — Returns `true` if the request was processed successfully.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### POSTRetryPaymentScheduleItemInfo

Information of the payment schedule items to be retried.

- `id` (string, optional) — Specifies the ID of the payment schedule item to be retried.
- `paymentGatewayId` (string, optional) — Specifies the ID of a payment gateway that will be used in the retry.
- `paymentMethodId` (string, optional) — Specifies the ID of a payment method that will be used in the retry.

### PaymentScheduleItemCommonResponse

Container for custom fields of a Payment Schedule Item object.

- `accountId` (string, optional) — ID of the customer account that owns the payment schedule item, for example `402880e741112b310149b7343ef81234`.
- `amount` (double, optional) — The total amount of the payment schedule.
- `balance` (double, optional) — The remaining balance of payment schedule item.
- `billingDocument` (PaymentScheduleItemCommonResponseBillingDocument, optional)
- `createdById` (string, optional) — The ID of the user who created the payment schedule item.
- `createdDate` (date, optional) — The date and time when the payment schedule item was created.
- `currency` (string, optional) — The currency of the payment.
- `description` (string, optional) — The description of the payment schedule item.
- `errorMessage` (string, optional) — The error message indicating if the error is related to configuration or payment collection.
- `id` (string, optional) — ID of the payment schedule item. For example, `412880e749b72b310149b7343ef81346`.
- `number` (string, optional) — Number of the payment schedule item.
- `paymentGatewayId` (string, optional, nullable) — ID of the payment gateway of the payment schedule item.
- `paymentMethodId` (string, optional, nullable) — ID of the payment method of the payment schedule item.
- `paymentOption` (list of PaymentSchedulePaymentOptionFields, optional) — Container for the paymentOption items, which describe the transactional level rules for processing payments. Currently, only the Gateway Options type is supported. `paymentOption` of the payment schedule takes precedence over `paymentOption` of the payment schedule item.
- `paymentScheduleId` (string, optional) — ID of the payment schedule that contains the payment schedule item, for example, `ID402880e749b72b310149b7343ef80005`.
- `paymentScheduleNumber` (string, optional) — Number of the payment schedule that contains the payment schedule item, for example, `ID402880e749b72b310149b7343ef80005`.
- `psiPayments` (list of LinkedPaymentID, optional) — Container for payments linked to the payment schedule item.
- `runHour` (integer, optional) — At which hour in the day in the tenant’s timezone this payment will be collected.
- `scheduledDate` (date, optional) — The scheduled date when the payment is processed.
- `standalone` (boolean, optional) — Indicates if the payment created by the payment schedule item is a standalone payment or not.
- `status` (enum, optional) — ID of the payment method of the payment schedule item. - `Pending`: Payment schedule item is waiting for processing. - `Processed`: The payment has been collected. - `Error`: Failed to collect the payment. - `Canceled`: After a pending payment schedule item is canceled by the user, the item is marked as `Canceled`.
  - Allowed values: `Pending`, `Processed`, `Error`, `Canceled`
- `updatedById` (string, optional) — The ID of the user who updated the payment schedule item.
- `updatedDate` (date, optional) — The date and time when the payment schedule item was last updated.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### PaymentScheduleItemCommonResponseBillingDocument

- `id` (string, optional) — ID of the billing document. for example, `2c9890306fb2121e016fb21a6b550041`.
- `number` (string, optional) — Number of the billing docuemnt, for example, `INV00002345`.
- `type` (string, optional) — Indicates whether the associated billing document is a debit memo or a invoice.

### PaymentSchedulePaymentOptionFields

- `detail` (PaymentSchedulePaymentOptionFieldsDetail, optional) — The field used to pass the transactional payment data to the gateway side in the key-value format.
- `type` (string, optional) — The type of the payment option. Currently, only `GatewayOptions` is supported for specifying Gateway Options fields supported by a payment gateway.

### LinkedPaymentID

- `paymentId` (string, optional) — ID of the payment.

### PaymentSchedulePaymentOptionFieldsDetail

The field used to pass the transactional payment data to the gateway side in the key-value format.

- `key` (string, optional) — The name of the field.
- `value` (string, optional) — The value of the field.

## Examples

**Request**

```json
{
  "items": [
    {
      "id": "402882e97f24bc36017f2986654f0253"
    },
    {
      "id": "402882e97f24bc36017f298665570254",
      "paymentGatewayId": "402883827d097a28017d09b41f690261",
      "paymentMethodId": "402882e97f24bc36017f258c2ff20076"
    }
  ]
}
```

**Response**

```json
{
  "items": [
    {
      "amount": null,
      "createdById": null,
      "createdDate": null,
      "currency": null,
      "description": null,
      "errorMessage": "Can not retry because payment Processed status is not allowed.",
      "id": "402882e97f24bc36017f2986654f0253",
      "paymentGatewayId": null,
      "paymentMethodId": null,
      "paymentScheduleId": "string",
      "paymentScheduleNumber": "string",
      "runHour": null,
      "scheduledDate": null,
      "status": null,
      "updatedById": null,
      "updatedDate": null,
      "paymentId": null
    },
    {
      "amount": 2,
      "createdById": "402881e522cf4f9b0122cf5d82860002",
      "createdDate": "2022-02-23",
      "currency": "USD",
      "description": null,
      "errorMessage": null,
      "id": "402882e97f24bc36017f298665570254",
      "paymentGatewayId": "402883827d097a28017d09b41f690261",
      "paymentMethodId": "402882e97f24bc36017f258c2ff20076",
      "paymentScheduleId": "string",
      "paymentScheduleNumber": "string",
      "runHour": 0,
      "scheduledDate": "2022-02-22",
      "status": "Processed",
      "updatedById": "402881e522cf4f9b0122cf5d82860002",
      "updatedDate": "2022-02-23",
      "PSIPaymentDate__c": "2022-02-22",
      "PSIPaymentPicklist__c": "1",
      "PSIPaymentText__c": "Payment Text From PSI via API Payment Error",
      "PSIPicklist__c": "1",
      "PSIText__c": "PSI Text Value",
      "paymentId": "402882e97f24bc36017f298efb360277"
    }
  ],
  "success": true
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/payment-schedule-items/retry-payment"

payload = { "items": [
        { "id": "402882e97f24bc36017f2986654f0253" },
        {
            "id": "402882e97f24bc36017f298665570254",
            "paymentGatewayId": "402883827d097a28017d09b41f690261",
            "paymentMethodId": "402882e97f24bc36017f258c2ff20076"
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/payment-schedule-items/retry-payment';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"items":[{"id":"402882e97f24bc36017f2986654f0253"},{"id":"402882e97f24bc36017f298665570254","paymentGatewayId":"402883827d097a28017d09b41f690261","paymentMethodId":"402882e97f24bc36017f258c2ff20076"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/payment-schedule-items/retry-payment"

	payload := strings.NewReader("{\n  \"items\": [\n    {\n      \"id\": \"402882e97f24bc36017f2986654f0253\"\n    },\n    {\n      \"id\": \"402882e97f24bc36017f298665570254\",\n      \"paymentGatewayId\": \"402883827d097a28017d09b41f690261\",\n      \"paymentMethodId\": \"402882e97f24bc36017f258c2ff20076\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/payment-schedule-items/retry-payment")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"items\": [\n    {\n      \"id\": \"402882e97f24bc36017f2986654f0253\"\n    },\n    {\n      \"id\": \"402882e97f24bc36017f298665570254\",\n      \"paymentGatewayId\": \"402883827d097a28017d09b41f690261\",\n      \"paymentMethodId\": \"402882e97f24bc36017f258c2ff20076\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/payment-schedule-items/retry-payment")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"items\": [\n    {\n      \"id\": \"402882e97f24bc36017f2986654f0253\"\n    },\n    {\n      \"id\": \"402882e97f24bc36017f298665570254\",\n      \"paymentGatewayId\": \"402883827d097a28017d09b41f690261\",\n      \"paymentMethodId\": \"402882e97f24bc36017f258c2ff20076\"\n    }\n  ]\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/payment-schedule-items/retry-payment', [
  'body' => '{
  "items": [
    {
      "id": "402882e97f24bc36017f2986654f0253"
    },
    {
      "id": "402882e97f24bc36017f298665570254",
      "paymentGatewayId": "402883827d097a28017d09b41f690261",
      "paymentMethodId": "402882e97f24bc36017f258c2ff20076"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/payment-schedule-items/retry-payment");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"items\": [\n    {\n      \"id\": \"402882e97f24bc36017f2986654f0253\"\n    },\n    {\n      \"id\": \"402882e97f24bc36017f298665570254\",\n      \"paymentGatewayId\": \"402883827d097a28017d09b41f690261\",\n      \"paymentMethodId\": \"402882e97f24bc36017f258c2ff20076\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["items": [
    ["id": "402882e97f24bc36017f2986654f0253"],
    [
      "id": "402882e97f24bc36017f298665570254",
      "paymentGatewayId": "402883827d097a28017d09b41f690261",
      "paymentMethodId": "402882e97f24bc36017f258c2ff20076"
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/payment-schedule-items/retry-payment")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```